datablock ParticleData(HumveeMGbulletTrailParticle)
{
	dragCoefficient      = 3;
	gravityCoefficient   = -0.0;
	inheritedVelFactor   = 1.0;
	constantAcceleration = 0.0;
	lifetimeMS           = 525;
	lifetimeVarianceMS   = 55;
	textureName          = "base/data/particles/dot";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "0.9 0.9 0.0 0.8";
	colors[1]     = "0.9 0.9 0.0 0.6";
	colors[2]     = "0.9 0.9 0.0 0.0";
	sizes[0]      = 0.06;
	sizes[1]      = 0.06;
	sizes[2]	  = 0.01;
	times[0]      = 0.0;
	times[1]	  = 0.9;
	times[2]      = 1.0;

	useInvAlpha = false;
};
datablock ParticleEmitterData(HumveeMGbulletTrailEmitter)
{
   ejectionPeriodMS = 8;
   periodVarianceMS = 0;
   ejectionVelocity = 0.0;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "HumveeMGbulletTrailParticle";
};

datablock ProjectileData(HumveeMGProjectile)
{
   projectileShapeName = "base/data/shapes/empty.dts";
   directDamage        = 15;
   directDamageType    = $DamageType::Gun;
   radiusDamageType    = $DamageType::Gun;

   brickExplosionRadius = 0;
   brickExplosionImpact = true;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 10;
   brickExplosionMaxVolume = 15;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 20;  //max volume of bricks that we can destroy if they aren't connected to the ground

   impactImpulse	     = 400;
   verticalImpulse	  = 300;
   explosion           = GunExplosion;
   particleEmitter     = HumveeMGbulletTrailEmitter;

   muzzleVelocity      = 180;
   velInheritFactor    = 1;

   armingDelay         = 00;
   lifetime            = 4000;
   fadeDelay           = 3500;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   isBallistic         = false;
   gravityMod = 0.0;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";
};

datablock ShapeBaseImageData(HUmveeMGSmokeImage)
{
	shapeFile = "base/data/shapes/empty.dts";
	emap = false;

	mountPoint = 1;

	stateName[0]                  = "Ready";
	stateTransitionOnTimeout[0]   = "FireA";
	stateTimeoutValue[0]          = 0.01;

	stateName[1]                  = "FireA";
	stateTransitionOnTimeout[1]   = "Done";
	stateWaitForTimeout[1]        = True;
	stateTimeoutValue[1]          = 0.05;
	stateEmitter[1]               = gunFlashEmitter;
	stateEmitterTime[1]           = 0.05;


	stateName[2]                  = "Done";
	stateScript[2]                = "onDone";
};
function HumveeMGSmokeImage::onDone(%this,%obj,%slot)
{
	%obj.unMountImage(%slot);
}

//audio
datablock AudioProfile(HumveeMGFireSound)
{
   filename    = "./HumveeMG_fire.wav";
   description = AudioClosest3d;
   preload = true;
};



//shell

datablock TSShapeConstructor(HumveeMGTurretDts)
{
	baseShape  = "./HumveeMGTurret.dts";
	sequence0  = "./MG_root.dsq root";

	sequence1  = "./MG_root.dsq run";
	sequence2  = "./MG_root.dsq walk";
	sequence3  = "./MG_root.dsq back";
	sequence4  = "./MG_root.dsq side";

	sequence5  = "./MG_root.dsq crouch";
	sequence6  = "./MG_root.dsq crouchRun";
	sequence7  = "./MG_root.dsq crouchBack";
	sequence8  = "./MG_root.dsq crouchSide";

	sequence9  = "./MG_look.dsq look";
	sequence10 = "./MG_root.dsq headside";
	sequence11 = "./MG_root.dsq headUp";

	sequence12 = "./MG_root.dsq jump";
	sequence13 = "./MG_root.dsq standjump";
	sequence14 = "./MG_root.dsq fall";
	sequence15 = "./MG_root.dsq land";

	sequence16 = "./MG_root.dsq armAttack";
	sequence17 = "./MG_root.dsq armReadyLeft";
	sequence18 = "./MG_root.dsq armReadyRight";
	sequence19 = "./MG_root.dsq armReadyBoth";
	sequence20 = "./MG_root.dsq spearready";  
	sequence21 = "./MG_root.dsq spearThrow";

	sequence22 = "./MG_root.dsq talk";  

	sequence23 = "./MG_root.dsq death1"; 
	
	sequence24 = "./MG_root.dsq shiftUp";
	sequence25 = "./MG_root.dsq shiftDown";
	sequence26 = "./MG_root.dsq shiftAway";
	sequence27 = "./MG_root.dsq shiftTo";
	sequence28 = "./MG_root.dsq shiftLeft";
	sequence29 = "./MG_root.dsq shiftRight";
	sequence30 = "./MG_root.dsq rotCW";
	sequence31 = "./MG_root.dsq rotCCW";

	sequence32 = "./MG_root.dsq undo";
	sequence33 = "./MG_root.dsq plant";

	sequence34 = "./MG_root.dsq sit";

	sequence35 = "./MG_root.dsq wrench";
};    	







datablock PlayerData(HumveeMGTurretPlayer)
{
   Hold = 1;

   renderFirstPerson = true;
   emap = false;
   
   className = Armor;
   shapeFile = "./HumveeMGTurret.dts";
   cameraMaxDist = 15;
   cameraTilt = 0.261;
   cameraVerticalOffset = 5.3;
   computeCRC = false;
  
   canObserve = true;
   cmdCategory = "Clients";

   cameraDefaultFov = 90.0;
   cameraMinFov = 5.0;
   cameraMaxFov = 120.0;
   
   //debrisShapeName = "~/data/player/debris_player.dts";
   //debris = horseDebris;

   aiAvoidThis = true;

   minLookAngle = -1.5708;
   maxLookAngle = 0.2;
   maxFreelookAngle = 3.0;

   mass = 200;
   drag = 10;
   maxdrag = 0.52;
   density = 0.7;
   maxDamage = 250;
   maxEnergy =  10;
   repairRate = 0.33;
   energyPerDamagePoint = 75.0;

   rechargeRate = 0.4;

   runForce = 0 * 0;
   runEnergyDrain = 0;
   minRunEnergy = 0;
   maxForwardSpeed = 0;
   maxBackwardSpeed = 0;
   maxSideSpeed = 0;

   maxForwardCrouchSpeed = 0;
   maxBackwardCrouchSpeed = 0;
   maxSideCrouchSpeed = 0;

   maxForwardProneSpeed = 0;
   maxBackwardProneSpeed = 0;
   maxSideProneSpeed = 0;

   maxForwardWalkSpeed = 0;
   maxBackwardWalkSpeed = 0;
   maxSideWalkSpeed = 0;

   maxUnderwaterForwardSpeed = 0;
   maxUnderwaterBackwardSpeed = 0;
   maxUnderwaterSideSpeed = 0;

   jumpForce = 0 * 0; //8.3 * 90;
   jumpEnergyDrain = 0;
   minJumpEnergy = 0;
   jumpDelay = 0;

   minJetEnergy = 0;
	jetEnergyDrain = 0;
	canJet = 0;

   recoverDelay = 0;
   recoverRunForceScale = 1.2;

   minImpactSpeed = 250;
   speedDamageScale = 3.8;

   boundingBox			= vectorScale("2.5 2.5 1.7", 4); 
   crouchBoundingBox	= vectorScale("2.5 2.5 1.7", 4); 
   proneBoundingBox	= vectorScale("2.5 2.5 1.7", 4); 

   pickupRadius = 0.75;
   
   // Damage location details
   boxNormalHeadPercentage       = 0.83;
   boxNormalTorsoPercentage      = 0.49;
   boxHeadLeftPercentage         = 0;
   boxHeadRightPercentage        = 1;
   boxHeadBackPercentage         = 0;
   boxHeadFrontPercentage        = 1;

   // Foot Prints
   //decalData   = HorseFootprint;
   //decalOffset = 0.25;
	
	
   jetEmitter = playerJetEmitter;
   jetGroundEmitter = playerJetGroundEmitter;
   jetGroundDistance = 4;
  
   //footPuffEmitter = LightPuffEmitter;
   footPuffNumParts = 10;
   footPuffRadius = 0.25;

   //dustEmitter = LiftoffDustEmitter;

   splash = PlayerSplash;
   splashVelocity = 4.0;
   splashAngle = 67.0;
   splashFreqMod = 300.0;
   splashVelEpsilon = 0.60;
   bubbleEmitTime = 0.1;
   splashEmitter[0] = PlayerFoamDropletsEmitter;
   splashEmitter[1] = PlayerFoamEmitter;
   splashEmitter[2] = PlayerBubbleEmitter;
   mediumSplashSoundVelocity = 10.0;   
   hardSplashSoundVelocity = 20.0;   
   exitSplashSoundVelocity = 5.0;

   // Controls over slope of runnable/jumpable surfaces
   runSurfaceAngle  = 85;
   jumpSurfaceAngle = 86;

   minJumpSpeed = 20;
   maxJumpSpeed = 30;

   horizMaxSpeed = 68;
   horizResistSpeed = 33;
   horizResistFactor = 0.35;

   upMaxSpeed = 80;
   upResistSpeed = 25;
   upResistFactor = 0.3;
   
   footstepSplashHeight = 0.35;

   //NOTE:  some sounds commented out until wav's are available


   // Footstep Sounds
   //FootSoftSound        = HorseFootFallSound;
   //FootHardSound        = HorseFootFallSound;
   //FootMetalSound       = HorseFootFallSound;
   //FootSnowSound        = HorseFootFallSound;
   //FootShallowSound     = HorseFootFallSound;
   //FootWadingSound      = HorseFootFallSound;
   //FootUnderwaterSound  = HorseFootFallSound;
   //FootBubblesSound     = FootLightBubblesSound;
   //movingBubblesSound   = ArmorMoveBubblesSound;
   //waterBreathSound     = WaterBreathMaleSound;

   //impactSoftSound      = ImpactLightSoftSound;
   //impactHardSound      = ImpactLightHardSound;
   //impactMetalSound     = ImpactLightMetalSound;
   //impactSnowSound      = ImpactLightSnowSound;
   
   //impactWaterEasy      = ImpactLightWaterEasySound;
   //impactWaterMedium    = ImpactLightWaterMediumSound;
   //impactWaterHard      = ImpactLightWaterHardSound;
   
   groundImpactMinSpeed    = 10.0;
   groundImpactShakeFreq   = "4.0 4.0 4.0";
   groundImpactShakeAmp    = "1.0 1.0 1.0";
   groundImpactShakeDuration = 0.8;
   groundImpactShakeFalloff = 10.0;
   
   //exitingWater         = ExitingWaterLightSound;
   
   observeParameters = "0.5 4.5 4.5";

   // Inventory Items
	maxItems   = 10;	//total number of bricks you can carry
	maxWeapons = 5;		//this will be controlled by mini-game code
	maxTools = 5;
	
	rideable = true;
   lookUpLimit = 0.6;
   lookDownLimit = 0.1;

	canRide = false;
	showEnergyBar = false;
	paintable = true;

	brickImage = horseBrickImage;	//the imageData to use for brick deployment

   numMountPoints = 1;
   mountThread[0] = "root";

   //protection for passengers
   protectPassengersBurn   = true;  //protect passengers from the burning effect of explosions?
   protectPassengersRadius = false;  //protect passengers from radius damage (explosions) ?
   protectPassengersDirect = false; //protect passengers from direct damage (bullets) ?
};

datablock WheeledVehicleData(HumveeMGVehicle)
{
	category = "Vehicles";
	displayName = " ";
	shapeFile = "./Humvee.dts"; //"~/data/shapes/skivehicle.dts"; //
	emap = true;
	minMountDist = 3;
	cost = 100;
   
   numMountPoints = 5;
   mountThread[0] = "sit";
   mountThread[1] = "sit";
   mountThread[2] = "sit";
   mountThread[3] = "sit";
   mountThread[4] = "root";

	maxDamage = 250.00;
	destroyedLevel = 200.00;
	speedDamageScale = 1.04;
	collDamageThresholdVel = 20.0;
	collDamageMultiplier   = 0.02;

	massCenter = "0 0 0";
   //massBox = "2 5 1";

	maxSteeringAngle = 0.9785;  // Maximum steering angle, should match animation
	integration = 4;           // Force integration time: TickSec/Rate
	tireEmitter = VehicleTireEmitter; // All the tires use the same dust emitter

	// 3rd person camera settings
	cameraRoll = false;         // Roll the camera with the vehicle
	cameraMaxDist = 13;         // Far distance from vehicle
	cameraOffset = 7.5;        // Vertical offset from camera mount point
	cameraLag = 0.0;           // Velocity lag of camera
	cameraDecay = 0.75;        // Decay per sec. rate of velocity lag
	cameraTilt = 0.4;
   collisionTol = 0.1;        // Collision distance tolerance
   contactTol = 0.1;

	useEyePoint = false;	

	defaultTire	= Humvee2Tire;
	defaultSpring	= Humvee2Spring;
	//flatTire	= Humvee2FlatTire;
	//flatSpring	= Humvee2FlatSpring;

   numWheels = 4;

	// Rigid Body
	mass = 300;
	density = 5.0;
	drag = 1.6;
	bodyFriction = 0.6;
	bodyRestitution = 0.6;
	minImpactSpeed = 10;        // Impacts over this invoke the script callback
	softImpactSpeed = 10;       // Play SoftImpact Sound
	hardImpactSpeed = 15;      // Play HardImpact Sound
	groundImpactMinSpeed    = 10.0;

	// Engine
	engineTorque = 12000; //4000;       // Engine power
	engineBrake = 2000;         // Braking when throttle is 0
	brakeTorque = 50000;        // When brakes are applied
	maxWheelSpeed = 30;        // Engine scale by current speed / max speed

	rollForce		= 900;
	yawForce		= 600;
	pitchForce		= 1000;
	rotationalDrag		= 0.2;

   // Advanced Steering
   steeringAutoReturn = true;
   steeringAutoReturnRate = 0.9;
   steeringAutoReturnMaxSpeed = 10;
   steeringUseStrafeSteering = true;
   steeringStrafeSteeringRate = 0.1;

	// Energy
	maxEnergy = 100;
	jetForce = 3000;
	minJetEnergy = 30;
	jetEnergyDrain = 2;
	isMULE = 1;

	splash = vehicleSplash;
	splashVelocity = 4.0;
	splashAngle = 67.0;
	splashFreqMod = 300.0;
	splashVelEpsilon = 0.60;
	bubbleEmitTime = 1.4;
	splashEmitter[0] = vehicleFoamDropletsEmitter;
	splashEmitter[1] = vehicleFoamEmitter;
	splashEmitter[2] = vehicleBubbleEmitter;
	mediumSplashSoundVelocity = 10.0;   
	hardSplashSoundVelocity = 20.0;   
	exitSplashSoundVelocity = 5.0;
		
	//mediumSplashSound = "";
	//hardSplashSound = "";
	//exitSplashSound = "";
	
	// Sounds
	//   jetSound = ScoutThrustSound;
	//engineSound = idleSound;
	//squealSound = skidSound;
	softImpactSound = slowImpactSound;
	hardImpactSound = fastImpactSound;
	//wheelImpactSound = slowImpactSound;

	//   explosion = VehicleExplosion;
	justcollided = 0;

   uiName = "Humvee- MG ";
	rideable = true;
		lookUpLimit = 0.65;
		lookDownLimit = 0.45;

	paintable = true;
   
   damageEmitter[0] = VehicleBurnEmitter;
	damageEmitterOffset[0] = "0.0 0.0 0.0 ";
	damageLevelTolerance[0] = 0.99;

   damageEmitter[1] = VehicleBurnEmitter;
	damageEmitterOffset[1] = "0.0 0.0 0.0 ";
	damageLevelTolerance[1] = 1.0;

   numDmgEmitterAreas = 1;

   initialExplosionProjectile = VehicleExplosionProjectile;
   initialExplosionOffset = 0;         //offset only uses a z value for now

   burnTime = 4000;

   finalExplosionProjectile = VehicleFinalExplosionProjectile;
   finalExplosionOffset = 0.5;          //offset only uses a z value for now

   minRunOverSpeed    = 4;   //how fast you need to be going to run someone over (do damage)
   runOverDamageScale = 8;   //when you run over someone, speed * runoverdamagescale = damage amt
   runOverPushScale   = 1.2; //how hard a person you're running over gets pushed

   //protection for passengers
   protectPassengersBurn   = false;  //protect passengers from the burning effect of explosions?
   protectPassengersRadius = true;  //protect passengers from radius damage (explosions) ?
   protectPassengersDirect = false; //protect passengers from direct damage (bullets) ?
};
function HumveeMGVehicle::onAdd(%this,%obj)
{

   // turret
 %t = new AIPlayer()
 {
   dataBlock = HumveeMGTurretPlayer;
};
MissionCleanup.add(%t);
%obj.mountObject(%t, 4);
%obj.turret = %t;
%obj.creationTime = getSimTime();
%t.schedule(10,"rigTurret");

//-------------------------------------cannon2

//-------------------------------------cannon3

//-------------------------------------cannon4





Parent::onAdd(%this,%obj);

}
function Player::rigTurret(%obj)
{
   if(%obj.dataBlock !$= HumveeMGTurretPlayer)
	   return;

   if(!isObject(%obj))
	   return;

   %parent = %obj.getObjectMount();
   if(!isObject(%parent))
	   return;

   %obj.spawnBrick = %parent.spawnBrick;
   %obj.brickGroup = %parent.brickGroup;
}
function HumveeMGVehicle::onRemove(%this,%obj)
{
   if(isObject(%obj.turret))
	   %obj.turret.delete();

}
function HumveeMGTurretPlayer::onDriverLeave(%this,%obj)
{
   %obj.setTransform("0 0 0 0 0 0 0");
}

package HumveeMGPackage
{

 
   function Player::burn(%obj,%time)
   {
      if(%obj.dataBlock $= HumveeMGTurretPlayer)
         return;
      else
         Parent::burn(%obj,%time);
   }

   function HumveeMGVehicle::Damage(%this,%obj,%source,%pos,%amm,%type)
   {
      if((%obj.getDamageLevel()+%amm) >= %this.maxDamage)
      {
         if(%obj.destroyed)
            return;

         %obj.setNodeColor("ALL","0 0 0 1");
         if(isObject(%obj.turret))
         {
            %obj.turret.delete();
         }
         else
         {
            %p = new Projectile()
            {
               dataBlock = HumveeMGExplosionProjectile;
               initialPosition = vectorAdd(%obj.getPosition(),"0 0" SPC %this.initialExplosionOffset);
               initialVelocity = "0 0 1";
               client = %obj.lastDamageClient;
               sourceClient = %obj.lastDamageClient;
            };
            MissionCleanup.add(%p);
         }
         if(%obj.destroyed)
            return;

         %obj.setDamageLevel(%this.maxDamage);
         %obj.destroyed = 1;
         %obj.schedule(%this.burnTime,"finalExplosion");
         if(isObject(%obj.spawnBrick.client.minigame))
            %respawn = %obj.spawnBrick.client.minigame.vehicleReSpawnTime;
         %obj.spawnBrick.schedule(%respawn,"spawnVehicle");
      }
      else
         Parent::Damage(%this,%obj,%source,%pos,%amm,%type);
   }
   
   function Player::emote(%obj,%emote)
   {
      if(%obj.dataBlock $= HumveeMGTurretPlayer)
	      return;
      Parent::emote(%obj,%emote);
   }
      function HumveeMGTurretPlayer::onDamage(%this,%obj,%ammount)
   {
      if(%obj.dataBlock $= HumveeMGTurretPlayer)
         return;
	   Parent::onDamage(%this,%obj,%ammount);
   }
   
   //------------------------------------------------------------------------------------------------------------------------------------------------------------
      function HumveeMGTurretPlayer::onDisabled(%this,%obj,%state)
   {
      %obj.schedule(10,"delete");
      %player = %obj.getMountedObject(0);
      if(isObject(%player))
      {
         %obj.getObjectMount().schedule(10,"mountObject",%player,4);
      }
   }

   function HumveeMGTurretPlayer::Damage(%this,%obj,%source,%pos,%amm,%type)
   {
      //scale the damage ammount as if this was a vehicle
      %amm *= $Damage::VehicleDamageScale[%type];

      if(%obj.getDamageLevel()+%amm > %this.maxDamage)
         %obj.setDamageLevel(%this.maxDamage);
      else
         Parent::Damage(%this,%obj,%source,%pos,%amm,%type);
   }

   function armor::onMount(%this,%obj,%col,%slot)
   {
      Parent::onMount(%this,%obj,%col,%slot);
      if(%col.getDataBlock() == HumveeMGVehicle.getId())
      {
         if(%slot $= 4)
         {
            %obj.setLookLimits(1,0);
         }
	

		 
      }
      else if(%col.getDataBlock() == HumveeMGTurretPlayer.getId())
      {
         %client = %obj.client;
         if(isObject(%client))
            ServerCmdUnUseTool(%client);
      }
   }

  function Player::HumveeShoot(%obj,%triggerNum,%val)
   {
      	if(!%val) 
	{
		cancel(%obj.Humvee_reshoot);
		return;
	}
      
      %mount = %obj.getObjectMount();

      //hack so we can shoot if we are a tank turret
      if(%obj.getDataBlock().getID() == HumveeMGTurretPlayer.getID())
         %mount = %obj;

      if(isObject(%mount))
      {
         if(%mount.getDataBlock() == HumveeMGTurretPlayer.getId() && %triggerNum == 0 && %val)
         {
            %client = %obj.client;
            if(isObject(%client))
               ServerCmdUnUseTool(%client);



	%vector = %mount.getEyeVector(); //Get the direction they're aiming
	%velocity = VectorScale(%vector, 80); //Lengthen the vector to be the speed of the projectile we want
	%x = (getRandom() - 0.5) * 0.02; //Calculate X, Y, and Z spread randomizations
	%y = (getRandom() - 0.5) * 0.02;
	%z = (getRandom() - 0.5) * 0.02;
	%mat = MatrixCreateFromEuler(%x SPC %y SPC %z);
	%velocity = MatrixMulVector(%mat, %velocity); //Randomize the lengthened vector.
	%scaleFactor = getWord(%mount.getScale(), 2); //Get the scale so we can scale the projectile.
	%p = new projectile() //Create the projectile.
	{
		dataBlock = HumveeMGprojectile;
		initialVelocity = %velocity;
		initialPosition = %mount.getEyePoint();
		sourceObject = %obj;
		sourceSlot = %triggerNum;
		client = %obj.client;
		scale = %scaleFactor;
	};
	MissionCleanup.add(%p);
	%mount.mountImage(HumveeMGSmokeImage,1);
	%mount.playThread(0,Spin);
	serverPlay3D(HumveeMGFireSound,%obj.getPosition());
	%obj.lastShotTime = getSimTime();
	%ReshootDelay = 100;
	%ShootDelay = 1000;
	%Hold = 1;
	if(%Hold == 1)
	{
		%obj.Humvee_reshoot= %obj.schedule(%ReshootDelay,HumveeShoot,%triggerNum,%val);
		//%obj.Humvee_reshoot= %obj.schedule(5,Humvee_Shoot,%triggerNum,%val);
	}

	%obj.client.Humvee_LastFireTime=$Sim::Time+%ShootDelay/1000;

            return;
         }
      }
      
   }




   
  function armor::onTrigger(%this, %obj, %triggerNum, %val)
   {
	if(%obj.getClassName()$="Player")
		{
			if(%triggerNum $= 0)
			{
				if(%val)
				{
					if($Sim::Time<%obj.client.Humvee_LastFireTime)
					{
					
						return;
					}
				}
				%obj.HumveeShoot(%triggerNum,%val);
			}
		}
	Parent::onTrigger(%this,%obj,%triggerNum,%val);
   }
   
   
   };
activatepackage(HumveeMGPackage);





datablock ExplosionData(HumveeMGExplosion)
{
   //explosionShape = "";
   lifeTimeMS = 150;

   soundProfile = vehicleExplosionSound;
   
   emitter[0] = vehicleExplosionEmitter;
   emitter[1] = vehicleExplosionEmitter2;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = true;
   camShakeFreq = "7.0 8.0 7.0";
   camShakeAmp = "10.0 10.0 10.0";
   camShakeDuration = 0.75;
   camShakeRadius = 15.0;

   // Dynamic light
   lightStartRadius = 0;
   lightEndRadius = 20;
   lightStartColor = "0.45 0.3 0.1";
   lightEndColor = "0 0 0";

   //impulse
   impulseRadius = 15;
   impulseForce = 1000;
   impulseVertical = 2000;

   //radius damage
   radiusDamage        = 30;
   damageRadius        = 8.0;

   //burn the players?
   playerBurnTime = 5000;

};

datablock ProjectileData(HumveeMGExplosionProjectile)
{
   directDamage        = 0;
   radiusDamage        = 0;
   damageRadius        = 0;
   explosion           = HumveeMGExplosion;

   directDamageType  = $DamageType::jeepExplosion;
   radiusDamageType  = $DamageType::jeepExplosion;

   explodeOnDeath		= 1;

   armingDelay         = 0;
   lifetime            = 10;
};




datablock DebrisData(HumveeMGDebris)
{
   emitters = "jeepDebrisTrailEmitter";

	shapeFile = "./Humvee.dts";
	lifetime = 3.0;
	minSpinSpeed = -300.0;
	maxSpinSpeed = 300.0;
	elasticity = 0.5;
	friction = 0.2;
	numBounces = 1;
	staticOnMaxBounce = true;
	snapOnMaxBounce = false;
	fade = true;

	gravModifier = 2;
};

datablock ExplosionData(HumveeMGFinalExplosion)
{
   //explosionShape = "";
   lifeTimeMS = 150;

   soundProfile = vehicleExplosionSound;
   
   emitter[0] = vehicleFinalExplosionEmitter3;
   emitter[1] = vehicleFinalExplosionEmitter2;

   particleEmitter = vehicleFinalExplosionEmitter;
   particleDensity = 20;
   particleRadius = 1.0;

   debris = HumveeMGDebris;
   debrisNum = 1;
   debrisNumVariance = 0;
   debrisPhiMin = 0;
   debrisPhiMax = 360;
   debrisThetaMin = 0;
   debrisThetaMax = 50;
   debrisVelocity = 15;
   debrisVelocityVariance = 3;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = true;
   camShakeFreq = "7.0 8.0 7.0";
   camShakeAmp = "10.0 10.0 10.0";
   camShakeDuration = 0.75;
   camShakeRadius = 15.0;

   // Dynamic light
   lightStartRadius = 0;
   lightEndRadius = 20;
   lightStartColor = "0.45 0.3 0.1";
   lightEndColor = "0 0 0";

   //impulse
   impulseRadius = 15;
   impulseForce = 1000;
   impulseVertical = 2000;

   //radius damage
   radiusDamage        = 30;
   damageRadius        = 8.0;

   //burn the players?
   playerBurnTime = 5000;

};

datablock ProjectileData(HumveeMGFinalExplosionProjectile)
{
   directDamage        = 0;
   radiusDamage        = 0;
   damageRadius        = 0;
   explosion           = HumveeMGFinalExplosion;

   directDamageType  = $DamageType::jeepExplosion;
   radiusDamageType  = $DamageType::jeepExplosion;

   explodeOnDeath		= 1;

   armingDelay         = 0;
   lifetime            = 10;
};